classdef DotFunction < Function
    
    properties(Access = private)
        f
        g
    end
    
    methods
        function obj = DotFunction(lhs, rhs)
           if ~isa(lhs, 'Function')
              error('The first argument must be of type function.'); 
           end
           
           if ~isa(rhs, 'Function')
              error('The second argument must be of type function.'); 
           end
           
           obj.f = lhs;
           obj.g = rhs;
        end
        
        function y = of(obj, x)
           y = obj.f.of(x) * obj.g.of(x); 
        end
    end
    
end