classdef HandleFunctionSystem < FunctionSystem
    
    properties(SetAccess = private)
       handles 
    end
    
    methods
       
        function obj = HandleFunctionSystem(varargin)
           if ~all(cellfun(@(F) isa(F, 'function_handle'), varargin))
              error('All arguments must be function handles'); 
           end
           
           obj.handles = varargin;
           obj.N = length(obj.handles);
        end
        
        function y = evaluate(obj, x)
            if ~isscalar(x)
               error('The argument must be a scalar.'); 
            end
            
            y = cellfun(@(f) f(x), obj.handles)';
        end
        
        function f = get(obj, i)
           %TODO: Code
        end
    end
    
end

